#include <sourcemod> //lol.
#include <sdktools> //Need this for slaying.
#include <colors> //Don't really need red in the chat, but...

new bool:iSlayClients[MAXPLAYERS+1]; //Create new array --Updated to bool.
new iSlayVotes; //Create new vote variable.
new bool:bCapped; //Create new capped? boolean.
new bool:bRoundEnd; //Create new round end? boolean.
new bool:bVoteInProgress //Create new is a vote in progress? boolean.
new Handle:hEnabled; //Create new plugin cvar handle.
#define SlayCap "{olive}[{red}SlayCap{olive}]{default}" //To make things easier.

public Plugin:myinfo = 
{ //Shouldn't need notes for these
	name 		= "Slay Cap",
	author 		= "Blue Kirby",
	description = "When a player caps, it creates a custom vote and asks if they should be slayed.",
	version 	= "0.8", //Not finished yet.
	url 		= "www.s3g.brainnerd.com/forum"
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
   CreateNative("SlayCapVoteStarting", Native_SlayCapVoteStarting);
   CreateNative("SlayCapVoteInProgress", Native_SlayCapVoteInProgress);
   return APLRes_Success;
}
public OnPluginStart()
{
	hEnabled = CreateConVar("sm_slay_cap_enabled", "1.0", "If slay cap is enabled.", _, true, 0.0, true, 1.0); //New CVar to tell the plugin if it is enabled.
	HookEvent("teamplay_round_start", Event_RoundStart); //Called when the round starts.
	HookEvent("teamplay_round_win", Event_RoundWin); //Called when the round is won.
	HookEvent("controlpoint_starttouch", SlayClientsAdd); //Have to use these for now because other.
	HookEvent("controlpoint_endtouch", SlayClientsRemove); //hooks were not working correctly.
	HookEvent("teamplay_point_captured", Event_PointCapped); //Called when the point is capped.
}
public OnClientPostAdminCheck(client)//Called when a player authorizes.
	if (!IsValidClient(client)) return; //Make sure they are valid; if not, return.
	else iSlayClients[client] = false; //Take them off the list, just in case.
public Action:Event_RoundStart(Handle:event, const String:name[], bool:dontBroadcast){
	if (bCapped)//If they have capped...
		CreateTimer(1.0, DelayShowVotePanel);//Delay just in case.
	else//If they haven't capped...
		for (new i = 1; i <= MAXPLAYERS; i++)//Get ALL the clients...
			iSlayClients[i] = false;//Take them off the list.
	
	bCapped = false; //Make sure it knows that there hasn't been a cap.
	bRoundEnd = false; //Make sure it knows the round has begun.
}
public Action:Event_RoundWin(Handle:event, const String:name[], bool:dontBroadcast) bRoundEnd = true;//Make sure it knows the round has ended.
public Action:DelayShowVotePanel(Handle:timer) ShowVotePanel();//Call the vote panel... bitch.
public Action:SlayClientsAdd(Handle:event, const String:name[], bool:dontBroadcast)
{
	decl client; //Create new temp variable...
	client = GetEventInt(event, "player"); //Get the player on the cap, what a faggot...
	if (!bRoundEnd && IsValidClient(client) && IsPlayerAlive(client)) //Check if the round is ended and client stuff...
		iSlayClients[client] = true; //Put them on the slay list.
}
public Action:SlayClientsRemove(Handle:event, const String:name[], bool:dontBroadcast) 
{
	decl client; //Create new temp variable...
	client = GetEventInt(event, "player"); //Get the player leaving the point...
	if (!bRoundEnd && IsValidClient(client) && IsPlayerAlive(client)) //Check if the round is ended and client stuff...
		iSlayClients[client] = false; //Take them off the slay list.
}
public Action:Event_PointCapped(Handle:event, const String:name[], bool:dontBroadcast) //Called when the point is captured.
{
	decl team; //Create new temp variable for the cap team...
	team = GetEventInt(event, "team"); //Set it equal to the team number.
	for (new client = 0;client <= MAXPLAYERS;client++) //Get ALL the clients...
		if (IsValidClient(client)) //Make sure they are valid...
			if (GetClientTeam(client) != team) //Make sure they are on the correct team...
				iSlayClients[client] = false; //Take them off the slay list
				
	bRoundEnd = true; //Show that the round has ended.
	bCapped = true; //Show that the point has been capped.
}
stock ShowVotePanel()//Create our panel.
{
	if (!GetConVarBool(hEnabled)) return; //Return of it is not enabled.
	bVoteInProgress = true; //Make sure they no the vote is not in progress.
	iSlayVotes = 0;//Set our votes to zero... bitch.
	new Handle:panel = CreatePanel();//Create new voting panel
	SetPanelTitle(panel, "Was it a justified cap?");//Title
	DrawPanelItem(panel, "Yes");//Option 1
	DrawPanelItem(panel, "No");//Option 2
	
	for (new client = 1; client <= MAXPLAYERS; client++)//Get ALL the clients...
		if (IsValidClient(client) && !iSlayClients[client])//Check if they are valid and stuff..
			SendPanelToClient(panel, client, VotePanelHandler, 13);//Send that vote panel to ALL the clients for 13 seconds.
 
	CloseHandle(panel);//Close the handle.
	CreateTimer(13.0, CheckIfShouldSlay);//Delay checking if slaying should occur.
}
public VotePanelHandler(Handle:menu, MenuAction:action, param, iVote)//Create our vote panel handler.
{
	if (!GetConVarBool(hEnabled)) return;
	if (action == MenuAction_Select)//Make sure they selected an item...
		if (iVote == 1) iSlayVotes++;//If they selected yes, then add 1 vote.
			else iSlayVotes--;//If they selected no, remove 1 vote.
}
public Action:CheckIfShouldSlay(Handle:timer)//Check if the clients should be slayed.
{
	if (!GetConVarBool(hEnabled)) return;
	bVoteInProgress = false; //Make sure they no the vote is not in progress.
	if (iSlayVotes >= 0)//If too many yes votes...
	{
		CPrintToChatAll("%sCap {olive}justified{default}!", SlayCap)//Tell everyone it was justified.
		for (new client = 1; client <= MAXPLAYERS; client++)//Get ALL the clients
			if (IsValidClient(client) && iSlayClients[client])//Check if they are valid.
				iSlayClients[client] = false;//Make sure we take them off the list.
		return;//Return so it doesn't try to slay their ass.
	}
	
	for (new client = 1; client <= MAXPLAYERS; client++)//Get ALL the clients
	{
		if (IsValidClient(client) && iSlayClients[client])//Check if they are valid and should they be slayed.
		{
			decl String:name[64];//Create new temp string.
			GetClientName(client, name, sizeof(name));//Get the name of the client we are slaying.
			CPrintToChatAll( "%sSlaying player {olive}%s {default}because of {red}unjustified {default}cap.", SlayCap, name );//Tell everyone they are dying.
			ForcePlayerSuicide(client);//Ahhhh... euthanasia.
		}
		iSlayClients[client] = false;//Make sure we take them off the list.
	}
}
stock GetSlayClientsCount() //Just in case someone feels like editing it or adding more checks.
{
	decl iClients; //Create new temp variable...
	for ( new client = 1; client <= MAXPLAYERS; client++ )//Get ALL the clients...
	{
		if (iSlayClients[client]) //Check if they should be slayed...
		iClients++; //Add 1 to iClients...
	}
	return iClients;//Return how many clients there is.
}
stock IsValidClient(client, bool:replaycheck = true)//Make sure they are valid.
{
	if (client <= 0 || client > MaxClients) return false;//If the valid is not within the bounds, return.
	if (!IsClientInGame(client)) return false; //If they aren't in the game, return.
	if (GetEntProp(client, Prop_Send, "m_bIsCoaching")) return false; //If they are coaching, return.
	if (replaycheck)//Check if they want to check replays.
		if (IsClientSourceTV(client) || IsClientReplay(client)) return false;
		
	return true;
}
public Native_SlayCapVoteStarting(Handle:plugin, numParams) return bCapped;
public Native_SlayCapVoteInProgress(Handle:plugin, numParams) return bVoteInProgress;